package org.diagbot.rule.lis;

import org.diagbot.nlp.rule.module.PreResult;
import org.springframework.util.StringUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description:
 * @Author: HUJING
 * @Date: 2019/9/25 13:33
 */
public class LisApplication {
    private static String up = "升高";
    private static String down = "降低";
    private static String normal = "正常";

    public List<PreResult> lisConvert(List<PreResult> preResultList) {
        if (preResultList != null) {
            for (PreResult result : preResultList) {
                if (isNumber(result.getValue())) {
                    if (!StringUtils.isEmpty(result.getMaxValue()) && !StringUtils.isEmpty(result.getMinValue())
                            && isNormal(result.getValue(), result.getMaxValue(), result.getMinValue())) {
                        result.setOtherValue(result.getUniqueName() + normal);
                    } else if (!StringUtils.isEmpty(result.getMaxValue())
                            && compareMax(result.getValue(), result.getMaxValue())) {
                        result.setOtherValue(result.getUniqueName() + up);
                    } else if (!StringUtils.isEmpty(result.getMinValue())
                            && compareMin(result.getValue(), result.getMinValue())) {
                        result.setOtherValue(result.getUniqueName() + down);
                    }
                } else {
                    result.setOtherValue(result.getValue());
                }
            }
        }
        return preResultList;
    }


    private boolean isNormal(String value, String maxValue, String minValue) {
        try {
            return Double.valueOf(value) < Double.valueOf(maxValue) && Double.valueOf(value) > Double.valueOf(minValue);
        } catch (Exception e) {
        }
        return false;
    }

    private boolean compareMin(String value, String minValue) {
        try {
            return Double.valueOf(value) < Double.valueOf(minValue);
        } catch (Exception e) {
        }
        return false;
    }

    private boolean compareMax(String value, String maxValue) {
        try {
            return Double.valueOf(value) > Double.valueOf(maxValue);
        } catch (Exception e) {
        }
        return false;
    }

    public static boolean isNumber(String value) {
        if (StringUtils.isEmpty(value)) {
            return false;
        }
        for (char c : value.toCharArray()) {
            if (c >= '0' && c <= '9') {
                return true;
            }
        }
        return false;
    }
}
